/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _draw_h_
#define _draw_h_

#include "meter.h"
#include "def.h"

#define CSYS_INIT   UInt16 OLD_CSYS=kCoordinatesNative;
#define CSYS_DOUBLE if(UtilIsHires()) OLD_CSYS = WinSetCoordinateSystem(kCoordinatesDouble);
#define CSYS_RESET  if(UtilIsHires()) WinSetCoordinateSystem(OLD_CSYS);

typedef struct
{
	Int16 x, y, r;
	Int16 elevation, azimuth;
	Int8 inv, wants_color, red, green, blue;
	Char *name;
	DmResID bitmap;
} SkyObjectData;

void DrawCompassBack(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawCompassNeedle(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawCompassScale(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawOdoBack(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawOdoNeedle(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawOdoScale(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawVarioBack(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawVarioNeedle(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawVarioScale(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawValue(meter_type *meter, draw_area_type *area) CODE2_SECTION;
void DrawSky(Int16 x, Int16 y, Int16 r) CODE2_SECTION;
void DrawSkyObject(SkyObjectData *data) CODE2_SECTION;
void DrawScale(RectangleType *rect, double scale, Boolean is_upright) CODE2_SECTION;

#endif /* _draw_h_ */
