/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _forms_h_
#define _forms_h_

#include "resource.h"
#include "def.h"

Boolean GPSFormHandler(EventPtr event) CODE2_SECTION;
Boolean GPS2FormHandler(EventPtr event) CODE2_SECTION;
Boolean ConfigFormHandler(EventPtr event) CODE3_SECTION;
Boolean MarkerFormHandler(EventPtr event) CODE3_SECTION;
Boolean MarkerEditFormHandler(EventPtr event) CODE2_SECTION;
Boolean SatDataFormHandler(EventPtr event) CODE3_SECTION;
Boolean TargetFormHandler(EventPtr event) CODE2_SECTION;
Boolean WorldFormHandler(EventPtr event) CODE2_SECTION;
Boolean TrackFormHandler(EventPtr event) CODE2_SECTION;
Boolean TrackDrawFormHandler(EventPtr event) CODE3_SECTION;
Boolean RawDataFormHandler(EventPtr event) CODE3_SECTION;
Boolean TrackManagerFormHandler(EventPtr event) CODE3_SECTION;
Boolean HelpFormHandler(EventPtr event) CODE4_SECTION;
Boolean RenameFormHandler(EventPtr event) CODE2_SECTION;
Boolean StartOdoFormHandler(EventPtr event) CODE4_SECTION;
#ifdef MOVINGMAP
Boolean MapDrawFormHandler(EventPtr event) CODE4_SECTION;
#endif /* MOVINGMAP */

#endif /* _forms_h_ */
