/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define BUFSIZE 256

int main(int argc, char **argv)
{
	int n;
	FILE *fp;
	char buf[BUFSIZE];

	if(argc != 2)
	{
		fprintf(stderr, "usage: %s <csv filename>\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	fp = fopen(argv[1], "r");
	if(fp == NULL)
	{
		perror("Failed to read file");
		return(EXIT_FAILURE);
	}

	printf("#ifndef _GEOIDAL_HEIGHT_PARAM_H_\n");
	printf("#define _GEOIDAL_HEIGHT_PARAM_H_\n\n");

	printf("Int8 GEOH[19][37] = \n");
	printf("\t{\n");

	n = 0;
	while(1)
	{
		char *s;

		s = fgets(buf, BUFSIZE, fp);
		if(s == NULL)
			break;
		if(n > 0) // skip first line
		{
			if(n > 1)
				printf(",\n");
			printf("\t\t{\n");
			int m = 0;
			for((s = strtok(buf, ";")), m = 0; s; s = strtok(NULL, ";"), m++)
			{
				if(m == 0)
					continue; // skip first value
				if(m > 1)
					printf(", ");
				printf("%s", s);
			}
			printf("\t\t}");
		}
		n++;
	}

	printf("\n\t};\n\n");

	printf("#endif //_GEOIDAL_HEIGHT_PARAM_H_\n");

	return(EXIT_SUCCESS);
}

