/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _main_h_
#define _main_h_

#include <PalmOS.h>
#include "nmea.h"

#define CGCreator		'coGP'
#define CGDBMarkerType	'DATA'
#define CGDBTrackType	'TRCK'
#define CGDBLogType		'LOGG'
#define CGDBMapType		'MAPP'
#define CGDBMarker		"cotoGPS MarkerDB"
#define CGDBLog			"cotoGPS LogDB"
#define CGDBTrack		"TRCK"
#define CGDBMap			"cotoGPS MapDB"

#define BEAM_MARKER		"Marker"
#define BEAM_MARKERDB	"MarkerDB"
#define BEAM_TRACK		"Track"

#define TITLE_MAX 40

#define TRACE(format, args...) HostTraceOutputTL(sysErrParamErr, format, ## args);

typedef struct
{
	MemPtr data;
} gps_ptr_type;
#define CASTRAW(event)  ((char*)((gps_ptr_type*)(event)->data.generic.datum)->data)
#define CASTNMEA(event) ((nmea_type*)((gps_ptr_type*)(event)->data.generic.datum)->data)

#define GpsNmeaEvent	firstUserEvent+0
#define GpsRawEvent		firstUserEvent+1
#define GpsPointSaved	firstUserEvent+2
#define GpsStart		firstUserEvent+3
#define GpsStop			firstUserEvent+4

void MainSetGPSTitle(FormPtr form);
void MainStartGPS();
void MainStopGPS();
void DoIque(UInt32 nparam);
void SetTitle(FormPtr form, Char *title, Boolean lean);
void SetTitleRes(FormPtr form, UInt16 res_id);
void ToggleRawData(FormPtr form);

#endif /* _main_h_ */
