/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc, char **argv)
{
	int i;
	double co = 2*M_PI/360.;
	FILE *fp = stdout;

	if(argc > 1)
	{
		fp = fopen(argv[1], "wb");
		if(fp == NULL)
		{
			perror("Failed to open file");
			return(EXIT_FAILURE);
		}
	}

	fprintf(fp, "#ifndef _SINCOS_H_\n");
	fprintf(fp, "#define _SINCOS_H_\n");

	fprintf(fp, "Int16 SIN[] = \n");
	fprintf(fp, "\t{\n");
	for(i = 0; i <= 90; i++)
	{
		if(i > 0)
			fprintf(fp, ",\n");
		fprintf(fp, "\t\t%d", (unsigned int)(0x7FFF*sin(i*co)));
	}
	fprintf(fp, "\n\t};\n");

	fprintf(fp, "#endif //_SINCOS_H_\n");

	if(fp != stdout)
		fclose(fp);

	return(EXIT_SUCCESS);
}

