/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

int main(int argc, char **argv)
{
	char *what, *with, *file, *buf, *c, *l;
	struct stat sb;
	FILE *fp;

	if(argc != 4)
	{
		fprintf(stderr, "usage: %s \"WHAT-string\" \"WITH-string\" filename\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	what = argv[1];
	with = argv[2];
	file = argv[3];

	//fprintf(stderr, "replacing \"%s\" with \"%s\" in file %s.\n", what, with, file);

	if(stat(file, &sb) != 0)
	{
		fprintf(stderr, "Failed to stat file \"%s\"\n", file);
		exit(EXIT_FAILURE);
	}
	buf = (char*)malloc(sb.st_size+1);
	if(buf == NULL)
	{
		fprintf(stderr, "Failed to malloc %ld bytes\n", sb.st_size);
		exit(EXIT_FAILURE);
	}

	fp = fopen(file, "r");
	if(fread(buf, 1, sb.st_size, fp) != sb.st_size)
	{
		fprintf(stderr, "Failed to fread %ld bytes\n", sb.st_size);
		exit(EXIT_FAILURE);
	}
	fclose(fp);
	buf[sb.st_size] = '\0';

	l = buf;
	while((c = strstr(l, what)) != NULL)
	{
		*c = '\0';
		printf(l);
		printf(with);
		l = c+strlen(what);
	}
	printf(l);

	free(buf);
	exit(EXIT_SUCCESS);
}

