/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* avoid 262 on HandEra */

#define MAX_MARKER_NAME_LENGTH  20
#define MAX_TRACK_NAME_LENGTH   32 //dmDBNameLength
#define MAX_MAP_NAME_LENGTH     32 //dmDBNameLength
#define MAX_LABEL_LENGTH	    64

#define START				1000
#define FORMIDS				START+0
#define PREFSID				START+100
#define GPSPAGEIDS			START+200
#define DESTIDS				START+300
#define DESTEDITIDS			START+400
#define MENUIDS				START+500
#define TRACKIDS			START+600
#define TRACKMANAGERIDS		START+700
#define TRACKDRAWIDS		START+800
#define TARGETIDS			START+900
#define HELPIDS				START+1000
#define SATIDS				START+1100
#define GPS2PAGEIDS			START+1200
#define ERRORID				START+1300
#define MISC				START+1400

#define GPSForm				FORMIDS+0
#define GPS2Form			FORMIDS+1
#define AlertForm			FORMIDS+2
#define AboutForm			FORMIDS+3
#define ConfigForm			FORMIDS+4
#define WorldForm			FORMIDS+5
#define SatDataForm			FORMIDS+6
#define TrackForm			FORMIDS+7
#define TrackDrawForm		FORMIDS+8
#define TrackManagerForm	FORMIDS+9
#define MarkerForm			FORMIDS+10
#define MarkerEditFormDD	FORMIDS+11
#define MarkerEditFormDMM	FORMIDS+12
#define MarkerEditFormDMS	FORMIDS+13
#define MarkerEditFormDMSS	FORMIDS+14
#define MarkerEditFormUTM	FORMIDS+15
#define MarkerEditFormOSGB	FORMIDS+16
#define MarkerEditFormQTH	FORMIDS+17
#define TargetForm			FORMIDS+18
#define HelpForm			FORMIDS+19
#define RawDataForm			FORMIDS+20
#define RenameForm			FORMIDS+21
#define StartOdoForm		FORMIDS+22
#define MapDrawForm			FORMIDS+23

#define NaviBitmapID		PREFSID+0
#define WorldBitmapID		PREFSID+1
#define SunUpBitmapID		PREFSID+2
#define SunDnBitmapID		PREFSID+3
#define MoonUpBitmapID		PREFSID+4
#define MoonDnBitmapID		PREFSID+5
#define AboutOKButton		PREFSID+6
#define ConfigOKButtonID	PREFSID+7
#define ConfigBTButtonID	PREFSID+8
#define BaudPopupTriggerID	PREFSID+9
#define BaudListID			PREFSID+10
#define PortPopupTriggerID	PREFSID+11
#define PortListID			PREFSID+12
#define TimeOffsetTriggerID	PREFSID+13
#define TimeOffsetListID	PREFSID+14
#define DistSpeedTriggerID	PREFSID+15
#define DistSpeedListID		PREFSID+16
#define AltFormatTriggerID	PREFSID+17
#define AltFormatListID		PREFSID+18
#define CoordFormatTriggerID	PREFSID+19
#define CoordFormatListID	PREFSID+20
#define UseNMEAWGS84ID		PREFSID+21
#define CorrectWGS84ID		PREFSID+22
#define DriftID				PREFSID+23
#define MaxSpeedID			PREFSID+24

#define SpeedID				GPSPAGEIDS+0
#define AltID				GPSPAGEIDS+1
#define CourseID			GPSPAGEIDS+2
#define DirectionID			GPSPAGEIDS+3
#define PDOPID				GPSPAGEIDS+4
#define HDOPID				GPSPAGEIDS+5
#define VDOPID				GPSPAGEIDS+6
#define LongitudeID			GPSPAGEIDS+7
#define LatitudeID			GPSPAGEIDS+8
#define DateID				GPSPAGEIDS+9
#define TimeID				GPSPAGEIDS+10
#define LatLabelID			GPSPAGEIDS+11
#define LonLabelID			GPSPAGEIDS+12

#define DestDetailsID		DESTIDS+0
#define DestListID			DESTIDS+1
#define DestNewID			DESTIDS+2
#define DestUseID			DESTIDS+3
#define DestNonID			DESTIDS+4
#define DestKeepID			DESTIDS+5
#define DestLatID			DESTIDS+6
#define DestLonID			DESTIDS+7
#define DestDistID			DESTIDS+8
#define DestMoveUpID		DESTIDS+9
#define DestMoveDownID		DESTIDS+10
#define DestSortID			DESTIDS+11
#define DestSortDistID		DESTIDS+12
#define DestSortAlphaID		DESTIDS+13
#define DestRefID			DESTIDS+14
#define DestRefLabelID		DESTIDS+15
#define DestCourseID		DESTIDS+16
#define DestCatPopupTriggerID	DESTIDS+17
#define DestCatListID		DESTIDS+18
#define DestLookUpLabelID	DESTIDS+19
#define DestLookUpID		DESTIDS+20

#define DestEditLonEWID		DESTEDITIDS+0
#define DestEditLonListID	DESTEDITIDS+1
#define DestEditLonDegID	DESTEDITIDS+2
#define DestEditLonMinID	DESTEDITIDS+3
#define DestEditLonSecID	DESTEDITIDS+4
#define DestEditLonDecID	DESTEDITIDS+5
#define DestEditLatNSID		DESTEDITIDS+6
#define DestEditLatListID	DESTEDITIDS+7
#define DestEditLatDegID	DESTEDITIDS+8
#define DestEditLatMinID	DESTEDITIDS+9
#define DestEditLatSecID	DESTEDITIDS+10
#define DestEditLatDecID	DESTEDITIDS+11
#define DestEditNameID		DESTEDITIDS+12
#define DestEditOKID		DESTEDITIDS+13
#define DestEditCancelID	DESTEDITIDS+14
#define DestEditDeleteID	DESTEDITIDS+15
#define DestEditHereID		DESTEDITIDS+16
#define DestEditFieldID		DESTEDITIDS+17
#define DestEditScrollBarID	DESTEDITIDS+18

#define MarkerFormID		MENUIDS+0
#define TrackFormID			MENUIDS+1
#define GPSFormID			MENUIDS+2
#define GPS2FormID			MENUIDS+3
#define TargetFormID		MENUIDS+4
#define SatDataID			MENUIDS+5
#define MenuAboutID			MENUIDS+6
#define MenuExitID			MENUIDS+7
#define DebugDataID			MENUIDS+8
#define ShowRawDataID		MENUIDS+9
#define HelpID				MENUIDS+10
#define ConfigID			MENUIDS+11
#define ResetStatsID		MENUIDS+12
#define ShowWorldID			MENUIDS+13
#define LogDBID				MENUIDS+14
#define ResetLogDBID		MENUIDS+15
#define TrackNameID			MENUIDS+16
#define TrackPointsID		MENUIDS+17
#define MemoryLeftID		MENUIDS+18
#define SyncTimeID			MENUIDS+19
#define SelectTrackID		MENUIDS+20
#define TrackManagerID		MENUIDS+21
#define MarkerEditMenuDD	MENUIDS+22
#define MarkerEditMenuDMM	MENUIDS+23
#define MarkerEditMenuDMS	MENUIDS+24
#define MarkerEditMenuDMSS	MENUIDS+25
#define MarkerEditMenuUTM	MENUIDS+26
#define MarkerEditMenuOSGB	MENUIDS+27
#define MarkerEditMenuQTH	MENUIDS+28
#define MarkerEditCrypt		MENUIDS+29
#define GPSOnOffID			MENUIDS+30
#define GPSOnBitmapID		MENUIDS+31
#define GPSOffBitmapID		MENUIDS+32

#define MainMenu			MENUIDS+50
#define MarkerMenu			MENUIDS+56
#define MarkerEditMenu		MENUIDS+57
#define TrackManagerMenu	MENUIDS+58
#define TrackDrawMenu		MENUIDS+59

#define TrackStartID		TRACKIDS+0
#define TrackStopID			TRACKIDS+1
#define TrackDrawID			TRACKIDS+2
#define TrackIntervalTID	TRACKIDS+3
#define TrackIntervalListID	TRACKIDS+4
#define TrackOffsetMID		TRACKIDS+5
#define TrackOffsetCID		TRACKIDS+6
#define TrackPushIID		TRACKIDS+7
#define TrackPushOID		TRACKIDS+8
#define TrackPushGroupID	TRACKIDS+9
#define TrackDoBeepID		TRACKIDS+10
#define TrackCalcDistID		TRACKIDS+11
#define TrackCalcAreaID		TRACKIDS+12
#define TrackCalcNullID		TRACKIDS+13
#define TrackPushLabelID	TRACKIDS+14
#define TrackOffsetPointID	TRACKIDS+15
#define TrackOffsetUnitID	TRACKIDS+16
#define TrackSaveLabelID	TRACKIDS+17
#define TrackDistLabelID	TRACKIDS+18
#define TrackAreaLabelID	TRACKIDS+19
#define AreaID				TRACKIDS+20
#define AreaTriggerID		TRACKIDS+21
#define AreaListID			TRACKIDS+22
#define DistanceID			TRACKIDS+23
#define DistTriggerID		TRACKIDS+24
#define DistListID			TRACKIDS+25
#define TrackDrawReturnID	TRACKIDS+50
#define TrackDrawModeID		TRACKIDS+51

#define TrackManagerListID		TRACKMANAGERIDS+0
#define TrackManagerNewID		TRACKMANAGERIDS+1
#define TrackManagerUseID		TRACKMANAGERIDS+2
#define TrackManagerCloseID		TRACKMANAGERIDS+3
#define TrackManagerDeleteID	TRACKMANAGERIDS+4
#define TrackManagerRenameID	TRACKMANAGERIDS+5
#define TrackManagerSendID		TRACKMANAGERIDS+6
#define TrackManagerPopupTID	TRACKMANAGERIDS+7
#define TrackManagerCatListID	TRACKMANAGERIDS+8
#define TrackSaveAsPDBID		TRACKMANAGERIDS+9
#define TrackSaveAsKMLID		TRACKMANAGERIDS+10

#define TrackDrawNoSelectID		TRACKDRAWIDS+0
#define TrackDrawMaxSpeedID		TRACKDRAWIDS+1
#define TrackDrawMaxAltID		TRACKDRAWIDS+2
#define TrackDrawMinAltID		TRACKDRAWIDS+3

#define TargetLatTarget		TARGETIDS+0
#define TargetLonTarget		TARGETIDS+1
#define TargetLatCurrent	TARGETIDS+2
#define TargetLonCurrent	TARGETIDS+3
#define TargetDist			TARGETIDS+4
#define TargetCourse		TARGETIDS+5
#define TargetLabel1ID		TARGETIDS+6
#define TargetLabel2ID		TARGETIDS+7
#define TargetInfoID		TARGETIDS+8

#define HelpDoneID			HELPIDS+0
#define HelpDownID			HELPIDS+1
#define HelpUpID			HELPIDS+2
#define HelpFont1ID			HELPIDS+3
#define HelpFont2ID			HELPIDS+4
#define HelpFont3ID			HELPIDS+5
#define HelpBtnID			HELPIDS+6

#define SatDataDoAstroID	SATIDS+0

#define MagVarID			GPS2PAGEIDS+0
#define MagVarDirID			GPS2PAGEIDS+1
#define ClimbID				GPS2PAGEIDS+2
#define PBatteryID			GPS2PAGEIDS+3
#define GBatteryID			GPS2PAGEIDS+4
#define STTLabelID			GPS2PAGEIDS+5
#define SpeedToTargetID		GPS2PAGEIDS+6
#define MeritFactorID		GPS2PAGEIDS+7

#define ErrorStringID		ERRORID+0
#define IntroHelpStrID		ERRORID+1
#define ConfigHelpStrID		ERRORID+2
#define WorldHelpStrID		ERRORID+3
#define MarkerHelpStrID		ERRORID+4
#define MarkerEditHelpStrID	ERRORID+5
#define GPSHelpStrID		ERRORID+6
#define GPS2HelpStrID		ERRORID+7
#define SatDataHelpStrID	ERRORID+8
#define TargetHelpStrID		ERRORID+9
#define TrackHelpStrID		ERRORID+10
#define TrackDrawHelpStrID	ERRORID+11
#define TrackManagerHelpStrID	ERRORID+12
#define HelpHelpStrID		ERRORID+13
#define RawDataHelpStrID	ERRORID+14
#define MapDrawHelpStrID	ERRORID+15

#define ErrorNOMEM				MISC+1
#define MainWRONGOS				MISC+2
#define MainNOMATHLIB			MISC+3
#define MainMATHLIBOPENFAILED	MISC+4
#define MainMATHLIBCLOSEFAILED	MISC+5
#define MainHELPPATCHFAILED		MISC+6
#define MainNOGPSLIB			MISC+7
#define MainGPSLIBOPEN			MISC+8
#define MapJPEGLIBOPENFAILED	MISC+9
#define MapJPEGFILEOPENFAILED	MISC+10
#define MapJPEGFILEREADFAILED	MISC+11

#define RenameHelpStrID			MISC+20
#define RenameFieldID			MISC+21
#define RenameOKID				MISC+22
#define RenameCancelID			MISC+23

#define StartOdoFormStrID		MISC+24
#define StartOdoFieldKMID		MISC+25
#define StartOdoFieldMID		MISC+26
#define StartOdoOKID			MISC+27
#define StartOdoCancelID		MISC+28

#define LogUSINGLOG				MISC+34
#define LogWRITINGLOG			MISC+35
#define LogNOLOG				MISC+36
#define LogDBCREATEFAILED		MISC+37
#define LogDBOPENFAILED			MISC+38
#define LogRECCREATEFAILED		MISC+39
#define LogRECREADFAILED		MISC+40
#define DbCREATEFAILED			MISC+41
#define DbDELETEFAILED			MISC+42
#define DbOPENFAILED			MISC+43
#define DbRECCREATEFAILED		MISC+44
#define DbGETDB					MISC+45
#define HelpTITLEHELP			MISC+46
#define HelpTITLEERR			MISC+47
#define HelpMISSINGRES			MISC+48
#define TitleDEMO				MISC+49
#define TitleLOG				MISC+50
#define TitleTRACK				MISC+51
#define TitleSYNC				MISC+52
#define TitleTAKEMARKER			MISC+53
#define TitleCALC				MISC+54
#define TitleMARKER				MISC+55
#define TitleTRACKMANAGER		MISC+56
#define TitleDRAWING			MISC+57
#define TitleERROR				MISC+58
#define TitleTRACKDRAW			MISC+59
#define TitleALTDRAW			MISC+60
#define TitleNOGPS				MISC+61
#define TitleGPSOFF				MISC+62
#define TitleNOFIX				MISC+63
#define TitleFIX				MISC+64
#define StringPOINTS			MISC+100
#define StringBYTES				MISC+101 // obsolete
#define StringMARKER			MISC+102
#define StringMARKERLIST		MISC+103
#define StringMARKERCATEGORY	MISC+104
#define StringLAT				MISC+105
#define StringLON				MISC+106
#define StringLATSHORT			MISC+107
#define StringLONSHORT			MISC+108
#define StringNORTHING			MISC+109
#define StringEASTING			MISC+110
#define StringNORTHINGSHORT		MISC+111
#define StringEASTINGSHORT		MISC+112
#define StringMAIDENHEAD		MISC+113
#define StringInternalMemory	MISC+114

#define BeamDESCR				MISC+200
#define BeamERRORTYPE			MISC+201
#define SendMarkerID			MISC+202
#define SendAllMarkerID			MISC+203
#define SendMarkerDBID			MISC+204
#define SendMarkerClipID		MISC+205
#define MARKERFORM_LISTADDED	MISC+206

