/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _serial_h_
#define _serial_h_

#include <PalmOS.h>

Boolean SerialInit() CODE2_SECTION;
void SerialFinish() CODE2_SECTION;
Boolean SerialIsIque() CODE2_SECTION;
Boolean SerialIsRunning() CODE2_SECTION;
void SerialGetSpeeds(UInt16 *cnt, Char ***items) CODE2_SECTION;
UInt32 SerialGetMaxSpeed(UInt16 devId) CODE2_SECTION;
void SerialGetDevices(UInt16 *cnt, Char ***items) CODE2_SECTION;
UInt16 SerialGetDefPort() CODE2_SECTION;
UInt16 SerialGetDefSpeed() CODE2_SECTION;
Err SerialOpenPortByIndex(Int16 portindex, Int16 speedindex) CODE2_SECTION;
Err SerialOpenPort(UInt32 port, UInt32 speed) CODE2_SECTION;
Err SerialClosePort() CODE2_SECTION;
Boolean SerialNextLine(char *buf) CODE2_SECTION;

void SerialSetDebug(Boolean db) CODE2_SECTION;
Boolean SerialIsDebug() CODE2_SECTION;

#endif /* _serial_h_ */
