/*
 * Copyright (c) 2010, Thomas Runge (trunge@truwo.de)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 * 	  notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * 	  notice, this list of conditions and the following disclaimer in the
 * 	  documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _time_h_
#define _time_h_

#include "def.h"

void TimeInit() CODE3_SECTION;
void TimeFinish() CODE3_SECTION;
Int16 TimeGetDefOffset() CODE3_SECTION;
void TimeGetOffsets(Int16 *cnt, Char ***items) CODE3_SECTION;
void TimeSetCurrentOffset(Int16 index) CODE3_SECTION;
Int32 TimeGetTimeOffset() CODE3_SECTION;
void TimeSetTime(Int16 hour, Int16 min, Int16 sec) CODE3_SECTION;
void TimeSetDate(Int16 year, Int16 month, Int16 day) CODE3_SECTION;
void TimeSetOwnDate() CODE3_SECTION;
UInt32 TimeGetGPSSeconds() CODE3_SECTION;
DateTimeType *TimeGetDateTime() CODE3_SECTION;
Char *TimeGetDateString() CODE3_SECTION;
Char *TimeGetTimeString() CODE3_SECTION;
void TimeSetPalmTime() CODE3_SECTION;

#endif /* _time_h_ */
